



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>spring cloud: Hystrix（二）：简单使用@HystrixCommand的commandProperties配置@HistrixProperty隔离策略</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">spring cloud: Hystrix（二）：简单使用@HystrixCommand的commandProperties配置@HistrixProperty隔离策略</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-26 02:03:12 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>spring cloud: Hystrix（二）：简单使用@HystrixCommand的commandProperties配置@HistrixProperty隔离策略</p>
<p>某电子商务网站在一个黑色星期五发生过载.过多的并发请求，导致用户支付的请求延迟很久没有响应，在等待很长时间后最终失败。支付失败又导致用户重新刷新页面并再次尝试支付，进一步增加了服务器的负载，最终整个系统都崩溃了。</p>
<p><strong>断路器模式</strong><br />一个远程调用对应着一个线程/进程。如果响应太慢，这个线程/进程就得不到释放。资源就会被耗尽，最终导致服务不可用。 <br />断路器可以理解为对容易导致错误的操作的代理。这种代理能够统计一段时间内调用失败的次数，并决定是正常请求依赖的服务还是直接返回。 <br />断路器可以实现快速失败，当它在一段时间内检测到许多类似的错误（例如超时），就会在之后的一段时间内，强迫对该服务的调用快速失败，即不再请求所依赖的服务。这样，应用程序就不须浪费CPU时间去等待长时间的超时。 <br />断路器也可以自动诊断依赖的服务是否已经恢复正常。</p>
<div>
<pre class="prettyprint linenums">正常情况下断路器关闭，可正常请求依赖的服务。<br />
当一段时间内，请求失败率达到一定阈值，断路器就会打开。此时，不会再去请求依赖的服务。<br />
断路器打开一段时间后，会自动进入&lsquo;半开&rsquo;状态。此时，断路器可允许一个请求访问依赖的服务。如果请求能够调用成功，则关闭断路器；否则继续保持打开状态。
</pre>
</div>
<p>　　</p>
<h2>Hystrix线程隔离策略与传播上下文</h2>
<p>Hystrix的隔离策略两种： 分别是线程隔离和信号量隔离。</p>
<p>THREAD(线程隔离）：使用该方式，HystrixCommand将会在单独的线程上执行，并发请求受线程池中线程数量的限制。<br />SEMAPHORE（信号量隔离）：使用该方式，HystrixCommand将会在调用线程上执行，开销相对较小，并发请求受到信号量个数的限制。 <br />Hystrix中默认并且推荐使用线程隔离（THREAD)，因为这种方式有一个除网络超时以外的额外保护。 <br />一般来说，只有当调用负载异常高时（例如每个实例每秒调用数百次）才需要信号量隔离，因为这种场景下使用THREAD开销会比较高。信号量隔离一般仅适用于非网络调用的隔离。 <br />可以使用execution.isolation.strategy属性指定隔离策略。<br />正常情况下，默认为线程隔离, 保持默认即可。 <br />如果发生找不到上下文运行时异常，可考虑将隔离策略设置为SEMAPHORE。</p>
<p><strong>Feign使用Hystrix</strong><br />前面讲的是使用注解@HystrixCommand的fallbackMethod属性实现回退的。然而，Feign是以接口形式工作的，它没有方法体。</p>
<p>q请看例文</p>
<div>
<pre class="prettyprint linenums">@RestController<br />
public class MovieController {

	@Autowired<br />
	private RestTemplate restTemplate;	

	@GetMapping("/movie/{id}")<br />
	@HystrixCommand(fallbackMethod = "notfindback", commandProperties=@HystrixProperty(name="execution.isolation.strategy", value="SEMAPHORE") )<br />
	public User findById(@PathVariable Long id)<br />
	{<br />
		//http://localhost:7900/simple/<br />
		return restTemplate.getForObject("http://spring-boot-user/simple/" + id, User.class);<br />
	}

	public User notfindback(Long id)<br />
	{<br />
		User user = new User();<br />
		user.setId(0L);<br />
		return user;

	}

}
</pre>
</div>
<p>　　</p>
<p>这一段代码：</p>
<div>
<pre class="prettyprint linenums">@GetMapping("/movie/{id}")<br />
	@HystrixCommand(fallbackMethod = "notfindback", commandProperties=@HystrixProperty(name="execution.isolation.strategy", value="SEMAPHORE") )<br />
	public User findById(@PathVariable Long id)<br />
	{<br />
		//http://localhost:7900/simple/<br />
		return restTemplate.getForObject("http://spring-boot-user/simple/" + id, User.class);<br />
	}
</pre>
</div>
<p>　　</p>
<p>如果不加@HystrixCommand的commandProperties=@HystrixProperty注解配置，那么：restTemplate.getForObject（）请求是一个线程；@HystrixCommand（）是一个隔离线程。</p>
<p>加上@HystrixCommand的commandProperties=@HystrixProperty注解配置后，将2个线程合并到一个线程里。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m96lmy94.html">Spring7：基于注解的Spring MVC（下篇）</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqljepx9.html">linux创建新用户以及修改密码</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq436538.html">C&num; 使用memcache（memcache安装）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8klex6q.html">21&period; javacript高级程序设计-Ajax与Comet</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96r33y9.html">VS调试技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq100x58.html">Centos6&period;4下Yum命令安装Mysql数据库及配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wd5joq.html">Android studio删除工程项目，androidstudio</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xoddw9.html">ThinkPHP讲解（七）&mdash;&mdash;修改删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvvjyjq.html">js获取时间格式化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okpgr59.html">Java基础知识强化之IO流笔记34：OutputStreamWriter（Writer字符流的子类）5种write数据方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1gm2x9.html">【Oracle】windows默认共享的打开和关闭？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeyxzz9.html">VelocityTracker简单介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/96or4r49.html">android 监听短信数据库，制作短信控制工具，控制别人的手机！！&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x4evg9.html">jsp之间url传值出现中文乱码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjj37x8.html">第一次测试HTML和CSS</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj01gl8.html">用C&num;写经理评分系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzv0pl8.html">Oozie调用Spark实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gew1y08.html">Hadoop综合大作业</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvvdgj8.html">shell丢弃信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwg3078.html">weui开发笔记</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8o100leq.html">ldap集成nexus</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gkel6q.html">hog cython</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvzoy38.html">复旦高等代数II（16级）每周一题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o107j1q.html">Win32汇编学习&lpar;3&rpar;：简单的窗口</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4lpjj9.html">论文笔记之：SeqGAN&colon; Sequence generative adversarial nets with policy gradient</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o5xk18.html">如何快速获取properties中的配置属性值</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o5myj8.html">Lintcode452-Remove Linked List Elements-Easy</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5253mq.html">理解 Redis&lpar;2&rpar; - 手把手教你理清 Redis 安装全过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwywy09.html">ImgNoGoodWindow</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o16425q.html">解決 Android Studio 不停 Indexing 的問題（Updating Indices&colon; Indexing paused due to batch update）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
